#!/usr/bin/perl -w
use strict;
use LWP::UserAgent;
use HTTP::Cookies;
use Compress::Zlib;

my $acc_data_file = $ARGV[0]; # путь и имя файла с логинами-паролями. передается в виде параметра ком. строки
my $base_url = 'http://www.the-game.ru'; # этот параметр без нужды менять не стоит.
my $time_interval = 2; # сообщения старше, чем "текущий_ход - $time_interval", будут проигнорированы.
my $msgbox = 2; # номер ящика сообщений (2 - Флоты).

############  Main  programm ##############
my %Accounts_Data = &ReadAccData($acc_data_file); # получаем хэш с логинами-паролями для акков
my $browser = &UAInit();
open (LOG,">./LOG.log"); 

foreach my $login (keys %Accounts_Data){
	my ($CurrentUser, $myID, $turn, $AccType) = &FirstAuth($login, $Accounts_Data{$login});
	if ($myID){
		&FleetCheck($base_url, $AccType, $msgbox, $turn, $time_interval);
		&LogOff($base_url, $AccType, $CurrentUser);
	}
}
close(LOG);
exit;
###########################

############ Procedure block ##############
sub ReadAccData($){
 open(ACCDATA, "<", $acc_data_file) or die ("Cannot open accounts data file: $!");
 while (<ACCDATA>) {
	chomp;
	s/#.*//;  # пропуск комментариев
	s/^\s+//; # пропуск пробелов в начале
	s/\s+$//; # и пробелов в конце строк
	next unless length; # пропуск пустых строк (переходим к след. итерации)
	# s/(\d+) ;.*/$1/; 
	my ($var, $value) = (split /\s+;\s+/, $_, 5)[3, 3]; # хер знает, как тут нормально разобрать строку :(
	$Accounts_Data{$var} = $value;
 }
 close(ACCDATA);
 print "Accounts data readed.\n";
 return (%Accounts_Data);
}

sub UAInit(){ # инициализация юзер-агента, прикидываемся браузером
 my $cookies=HTTP::Cookies->new('file'=>'./cookies.lwp','autosave'=>0);
 my $browser=LWP::UserAgent->new('agent' => 'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11)',
								  'cookie_jar' => $cookies,
								  'requests_redirectable' => ['GET', 'POST']);
 $browser->default_header('Accept' => 'text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1',
						'Accept-Charset' => 'utf-8; *;q=0.1',
						'Accept-Language' => 'ru,en-us;q=0.7,en;q=0.3',
						'Accept-Encoding' => 'deflate, gzip, x-gzip, identity, *;q=0',
						);
#	$browser->proxy([qw(http https)], 'http://127.0.0.1:50000');
 return ($browser);
}

sub FirstAuth($$$){
 my ($login, $pass) = @_;
  next if length($pass) < 8; # переходим к след. акку, если логин и пароль распарсились криво - косяк разбора входного файла, см. ф-ю ReadAccData
 my $response = $browser->post($base_url. '/overview/',
    [
     'action'	=> 'login',
     'login'	=> $login,
     'pwd'		=> $pass,
    ]);
	do {print "Connection error: ".$response->status_line,"\n"; next;} unless $response->is_success;
 my $source = Compress::Zlib::memGunzip(\($response->content)[0]);

 my $CurrentUser = $1 if $source =~ /.+?::.+?::\s(.*)<\/title>/;
 my $myID = $1 if $source =~ /var PlayerId=(\d{1,7});/;
 my $turn = $1 if $source =~ /var TurnN=(\d{4});/;
 my $AccType = $1 if $source =~ /Paid=(\d);/;
 print "\n>>>>>User logged in us player $CurrentUser (ID= $myID). L/P: $login\n" if $CurrentUser && $myID;
 print LOG "\n>>>>>User logged in us player $CurrentUser (ID= $myID). L/P: $login\n" if $CurrentUser && $myID;
return ($CurrentUser, $myID, $turn, $AccType);
}

sub FleetCheck($$$$$){
#Checkin fleets warning messages
 my ($base_url, $AccType, $msgbox, $turn, $time_interval) = @_;
 $base_url =~ s/www/free/ if $AccType == 0;
 my $response = $browser->get($base_url. '/blackframes/fetch_msgs/on/0/?box='. $msgbox);
	do {print "Connection error: ".$response->status_line; next;} unless $response->is_success;
 my $source = Compress::Zlib::memGunzip(\($response->content)[0]);
 while($source =~ /\{r:(\d{1,}),s:'(В(?:аш|аше|ы)\D+?|Схватка\D+?|Успех\D+?|Your\D+?|Surface\D+?)',d:'(\d{2,})-(\d{2,}) (\d{2,}:\d{2,})',i:\d+,t:\d+,f:'',o:'',h:\d+,toString:TS,c:\d{1,},m:(\d{4,5}),x:(\d{1,4}),y:(\d{1,4})\},/gsc){
	print "$2:\t$4.$3-$5, $6, $7:$8\n" if $1 == 0 and $6 >= $turn- $time_interval;
	print LOG "$2:\t$4.$3-$5, $6, $7:$8\n" if $1 == 0 and $6 >= $turn- $time_interval;
 }
}

sub LogOff($$$){
 my ($base_url, $AccType, $CurrentUser) = @_;
 $base_url =~ s/www/free/ if $AccType == 0;
 my $response = $browser->get($base_url. '/logoff/');
 print "$CurrentUser is logged off.\n" if $response->is_success;
 print LOG "$CurrentUser is logged off.\n" if $response->is_success;
}
